--- src/tables/eit.c.orig	2007-04-07 21:03:20.000000000 +0200
+++ src/tables/eit.c	2007-04-07 21:05:39.000000000 +0200
@@ -418,13 +418,9 @@
 
     /* Check if we have all the sections */
     b_complete = 0;
-    for(i = 0; i <= p_eit_decoder->i_last_section_number; i++)
-    {
-      if(!p_eit_decoder->ap_sections[i])
-        break;
-
-      if(i == p_eit_decoder->i_last_section_number)
-        b_complete = 1;
+    if (p_eit_decoder->ap_sections[0] != NULL &&
+        p_section->i_number == p_eit_decoder->i_last_section_number) {
+      b_complete = 1;
     }
 
     if(b_complete)
@@ -435,9 +431,17 @@
       /* Chain the sections */
       if(p_eit_decoder->i_last_section_number)
       {
-        for(i = 0; i <= p_eit_decoder->i_last_section_number - 1; i++)
-          p_eit_decoder->ap_sections[i]->p_next =
-                                        p_eit_decoder->ap_sections[i + 1];
+        dvbpsi_psi_section_t * p_last_section;
+
+        p_last_section = p_eit_decoder->ap_sections[0];
+        for(i = 1; i <= p_eit_decoder->i_last_section_number; i++)
+        {
+          if (p_eit_decoder->ap_sections[i] != NULL)
+          {
+            p_last_section->p_next = p_eit_decoder->ap_sections[i];
+            p_last_section = p_eit_decoder->ap_sections[i];
+          }
+        }
       }
       /* Decode the sections */
       dvbpsi_DecodeEITSections(p_eit_decoder->p_building_eit,
